"use strict";
var interfaces_1 = require('../interfaces');
var get_getter_names_1 = require('../library/get-getter-names');
function createGettersDecorator(callback) {
    return function (ServiceToDecorate) {
        get_getter_names_1.getPublicGetterNames(ServiceToDecorate)
            .forEach(function (getterName) {
            var original = Object.getOwnPropertyDescriptor(ServiceToDecorate.prototype, getterName);
            Object.defineProperty(ServiceToDecorate.prototype, getterName, {
                get: function () {
                    var _this = this;
                    var returnValue = original.get.apply(this);
                    callback({
                        clazz: ServiceToDecorate,
                        method: getterName,
                        returnValue: returnValue,
                        input: null,
                        instance: this,
                        type: interfaces_1.EventType.getter
                    });
                    if (!returnValue.subscribe)
                        return returnValue;
                    return returnValue.do(function (value) {
                        callback({
                            clazz: ServiceToDecorate,
                            method: getterName,
                            returnValue: value,
                            input: null,
                            instance: _this,
                            type: interfaces_1.EventType.firedGetter
                        });
                    });
                }
            });
        });
    };
}
exports.createGettersDecorator = createGettersDecorator;
//# sourceMappingURL=getters.js.map