"use strict";
var get_function_names_1 = require('../library/get-function-names');
var interfaces_1 = require('../interfaces');
var wrap_method_1 = require('../library/wrap-method');
function createMethodDecorator(callback) {
    return function (ServiceToDecorate) {
        get_function_names_1.getPublicFunctionNames(ServiceToDecorate)
            .forEach(function (functionName) {
            var originalMethod = ServiceToDecorate.prototype[functionName];
            var before = function () { };
            var after = function (instance, returnValue) {
                var args = [];
                for (var _i = 2; _i < arguments.length; _i++) {
                    args[_i - 2] = arguments[_i];
                }
                callback({
                    clazz: ServiceToDecorate,
                    method: functionName,
                    returnValue: returnValue,
                    input: args,
                    instance: instance,
                    type: interfaces_1.EventType.method
                });
            };
            ServiceToDecorate.prototype[functionName] = wrap_method_1.wrapMethod(originalMethod, { before: before, after: after });
        });
    };
}
exports.createMethodDecorator = createMethodDecorator;
//# sourceMappingURL=method.js.map