"use strict";
var get_property_descriptors_1 = require('./get-property-descriptors');
var R = require('ramda');
function getPublicGetterNames(Clazz) {
    return get_property_descriptors_1.getPropertyDescriptors(Clazz)
        .filter(function (property) { return typeof property.descriptor.value !== 'function'; })
        .filter(R.curry(isGetter)(Clazz))
        .map(function (property) { return property.name; });
}
exports.getPublicGetterNames = getPublicGetterNames;
function isGetter(Clazz, property) {
    return Object.getOwnPropertyDescriptor(Clazz.prototype, property.name).set === undefined;
}
//# sourceMappingURL=get-getter-names.js.map