"use strict";
function wrapMethod(method, _a) {
    var before = _a.before, after = _a.after;
    return function wrapped() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (before)
            before.apply(void 0, [this].concat(args));
        var returnValue = method.apply(this, args);
        if (after)
            after.apply(void 0, [this, returnValue].concat(args));
        return returnValue;
    };
}
exports.wrapMethod = wrapMethod;
//# sourceMappingURL=wrap-method.js.map